/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2024 KylinSoft  Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#include <gtest/gtest.h>
#include <gtest/gtest-death-test.h>
#include <QDebug>

#include "../../plugins/component/RadioItemButton/radioitembutton.h"

#include "stubext.h"
using namespace stub_ext;

class RadioItemButtonTest : public testing::Test
{
protected:
    static void SetUpTestSuite()
    {
        m_pRadioItemButtonTest = new RadioItemButton();
    }

    static void TearDownTestSuite()
    {
        if (m_pRadioItemButtonTest) {
            delete m_pRadioItemButtonTest;
            m_pRadioItemButtonTest = nullptr;
        }
    }
    static RadioItemButton *m_pRadioItemButtonTest;
};

RadioItemButton *RadioItemButtonTest::m_pRadioItemButtonTest = nullptr;

TEST_F(RadioItemButtonTest, testAllFunc)
{
    QIcon icon("");
    m_pRadioItemButtonTest->setButtonIcon(icon);
    m_pRadioItemButtonTest->setDefaultPixmap();
    m_pRadioItemButtonTest->setActive(true);
    m_pRadioItemButtonTest->setActive(false);

    //    QPaintEvent *p_paintEvent;
    //    m_pRadioItemButtonTest->paintEvent(p_paintEvent);
    //    QMouseEvent *p_mouseEvent;
    //    m_pRadioItemButtonTest->mousePressEvent(p_mouseEvent);
    //    m_pRadioItemButtonTest->mouseReleaseEvent(p_mouseEvent);
    //    QEvent *p_event;
    //    m_pRadioItemButtonTest->enterEvent(p_event);
    //    m_pRadioItemButtonTest->leaveEvent(p_event);

    m_pRadioItemButtonTest->refreshButtonIcon();

    m_pRadioItemButtonTest->onPaletteChanged();
}
